/* Circular buffer for items of type ValueType.
 * Tim Bailey 2003. */

#ifndef CIRC_BUFFER_H_
#define CIRC_BUFFER_H_

typedef double ValueType;
typedef struct CircBuf_t CircBuf;

/* create-destroy buffer */
CircBuf *create_buffer(int size);
void destroy_buffer(CircBuf *cb);

/* add-remove elements */
int add_item(CircBuf *cb, const ValueType *item);
int get_item(CircBuf *cb, ValueType *item);

/* query state */
int get_nitems(const CircBuf *cb);
int get_size(const CircBuf *cb);

#endif
